| OGRE 1.11.1 Object-Oriented Graphics Rendering Engine

Public Member Functions | Static Public Member Functions | List of all members
Ogre::ParticleSystemRenderer Class Referenceabstract
Core » Effects

Abstract class defining the interface required to be implemented by classes which provide rendering capability to ParticleSystem instances. More...

`#include <OgreParticleSystemRenderer.h>`

Inheritance diagram for Ogre::ParticleSystemRenderer:
[legend]

## Public Member Functions
| ParticleSystemRenderer ()
| Constructor. More...
virtual | ~ParticleSystemRenderer ()
| Destructor. More...
virtual ParticleVisualData * | _createVisualData (void)
| Create a new ParticleVisualData instance for attachment to a particle. More...
virtual void | _destroyVisualData (ParticleVisualData *vis)
| Destroy a ParticleVisualData instance. More...
virtual SortMode | _getSortMode (void) const =0
| Gets the desired particles sort mode of this renderer. More...
virtual void | _notifyAttached (Node *parent, bool isTagPoint=false)=0
| Delegated to by ParticleSystem::_notifyAttached. More...
virtual void | _notifyCurrentCamera (Camera *cam)=0
| Delegated to by ParticleSystem::_notifyCurrentCamera. More...
virtual void | _notifyDefaultDimensions (Real width, Real height)=0
| Tells the renderer that the particle default size has changed. More...
virtual void | _notifyParticleCleared (std::list< Particle *> &currentParticles)
| Optional callback notified when particles cleared. More...
virtual void | _notifyParticleEmitted (Particle *particle)
| Optional callback notified when particle emitted. More...
virtual void | _notifyParticleExpired (Particle *particle)
| Optional callback notified when particle expired. More...
virtual void | _notifyParticleMoved (std::list< Particle *> &currentParticles)
| Optional callback notified when particles moved. More...
virtual void | _notifyParticleQuota (size_t quota)=0
| Tells the renderer that the particle quota has changed. More...
virtual void | _notifyParticleResized (void)
| Optional callback notified when particles are resized individually. More...
virtual void | _notifyParticleRotated (void)
| Optional callback notified when particles are rotated. More...
virtual void | _setMaterial (MaterialPtr &mat)=0
| Sets the material this renderer must use; called by ParticleSystem. More...
virtual void | _updateRenderQueue (RenderQueue *queue, std::list< Particle *> &currentParticles, bool cullIndividually)=0
| Delegated to by ParticleSystem::_updateRenderQueue. More...
void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object. More...
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class. More...
const ParamDictionary * | getParamDictionary (void) const
String | getParameter (const String &name) const
| Generic parameter retrieval method. More...
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object. More...
virtual const String & | getType (void) const =0
| Gets the type of this renderer - must be implemented by subclasses. More...
virtual void | setKeepParticlesInLocalSpace (bool keepLocal)=0
| Setting carried over from ParticleSystem. More...
bool | setParameter (const String &name, const String &value)
| Generic parameter setting method. More...
void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method. More...
virtual void | setRenderQueueGroup (uint8 queueID)=0
| Sets which render queue group this renderer should target with it's output. More...
virtual void | setRenderQueueGroupAndPriority (uint8 queueID, ushort priority)=0
| Sets which render queue group and priority this renderer should target with it's output. More...
virtual void | visitRenderables (Renderable::Visitor *visitor, bool debugRenderables=false)=0
| Required method to allow the renderer to communicate the Renderables it will be using to render the system to a visitor. More...

## Static Public Member Functions
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g. More...

## Detailed Description

Abstract class defining the interface required to be implemented by classes which provide rendering capability to ParticleSystem instances.

## Constructor & Destructor Documentation

## ◆ ParticleSystemRenderer()

Ogre::ParticleSystemRenderer::ParticleSystemRenderer | ( |  | ) |
| inline

Constructor.

## ◆ ~ParticleSystemRenderer()

virtual Ogre::ParticleSystemRenderer::~ParticleSystemRenderer | ( |  | ) |
| inline virtual

Destructor.

## Member Function Documentation

## ◆ getType()

virtual const String& Ogre::ParticleSystemRenderer::getType | ( | void |  | ) | const
| pure virtual

Gets the type of this renderer - must be implemented by subclasses.

Implemented in Ogre::BillboardParticleRenderer.

## ◆ _updateRenderQueue()

virtual void Ogre::ParticleSystemRenderer::_updateRenderQueue | ( | RenderQueue * | queue,
|  | std::list< Particle *> & | currentParticles,
|  | bool | cullIndividually
| ) |  |
| pure virtual

Delegated to by ParticleSystem::_updateRenderQueue.

Remarks
  The subclass must update the render queue using whichever Renderable instance(s) it wishes.

Implemented in Ogre::BillboardParticleRenderer.

## ◆ _setMaterial()

virtual void Ogre::ParticleSystemRenderer::_setMaterial | ( | MaterialPtr & | mat | ) |
| pure virtual

Sets the material this renderer must use; called by ParticleSystem.

Implemented in Ogre::BillboardParticleRenderer.

## ◆ _notifyCurrentCamera()

virtual void Ogre::ParticleSystemRenderer::_notifyCurrentCamera | ( | Camera * | cam | ) |
| pure virtual

Delegated to by ParticleSystem::_notifyCurrentCamera.

Implemented in Ogre::BillboardParticleRenderer.

## ◆ _notifyAttached()

virtual void Ogre::ParticleSystemRenderer::_notifyAttached | ( | Node * | parent,
|  | bool | isTagPoint = `false`
| ) |  |
| pure virtual

Delegated to by ParticleSystem::_notifyAttached.

Implemented in Ogre::BillboardParticleRenderer.

## ◆ _notifyParticleRotated()

virtual void Ogre::ParticleSystemRenderer::_notifyParticleRotated | ( | void |  | ) |
| inline virtual

Optional callback notified when particles are rotated.

Reimplemented in Ogre::BillboardParticleRenderer.

## ◆ _notifyParticleResized()

virtual void Ogre::ParticleSystemRenderer::_notifyParticleResized | ( | void |  | ) |
| inline virtual

Optional callback notified when particles are resized individually.

Reimplemented in Ogre::BillboardParticleRenderer.

## ◆ _notifyParticleQuota()

virtual void Ogre::ParticleSystemRenderer::_notifyParticleQuota | ( | size_t | quota | ) |
| pure virtual

Tells the renderer that the particle quota has changed.

Implemented in Ogre::BillboardParticleRenderer.

## ◆ _notifyDefaultDimensions()

virtual void Ogre::ParticleSystemRenderer::_notifyDefaultDimensions | ( | Real | width,
|  | Real | height
| ) |  |
| pure virtual

Tells the renderer that the particle default size has changed.

Implemented in Ogre::BillboardParticleRenderer.

## ◆ _notifyParticleEmitted()

virtual void Ogre::ParticleSystemRenderer::_notifyParticleEmitted | ( | Particle * | particle | ) |
| inline virtual

Optional callback notified when particle emitted.

## ◆ _notifyParticleExpired()

virtual void Ogre::ParticleSystemRenderer::_notifyParticleExpired | ( | Particle * | particle | ) |
| inline virtual

Optional callback notified when particle expired.

## ◆ _notifyParticleMoved()

virtual void Ogre::ParticleSystemRenderer::_notifyParticleMoved | ( | std::list< Particle *> & | currentParticles | ) |
| inline virtual

Optional callback notified when particles moved.

## ◆ _notifyParticleCleared()

virtual void Ogre::ParticleSystemRenderer::_notifyParticleCleared | ( | std::list< Particle *> & | currentParticles | ) |
| inline virtual

Optional callback notified when particles cleared.

## ◆ _createVisualData()

virtual ParticleVisualData* Ogre::ParticleSystemRenderer::_createVisualData | ( | void |  | ) |
| inline virtual

Create a new ParticleVisualData instance for attachment to a particle.

Remarks
  If this renderer needs additional data in each particle, then this should be held in an instance of a subclass of ParticleVisualData, and this method should be overridden to return a new instance of it. The default behaviour is to return null.

## ◆ _destroyVisualData()

virtual void Ogre::ParticleSystemRenderer::_destroyVisualData | ( | ParticleVisualData * | vis | ) |
| inline virtual

Destroy a ParticleVisualData instance.

Remarks
  If this renderer needs additional data in each particle, then this should be held in an instance of a subclass of ParticleVisualData, and this method should be overridden to destroy an instance of it. The default behaviour is to do nothing.

## ◆ setRenderQueueGroup()

virtual void Ogre::ParticleSystemRenderer::setRenderQueueGroup | ( | uint8 | queueID | ) |
| pure virtual

Sets which render queue group this renderer should target with it's output.

Implemented in Ogre::BillboardParticleRenderer.

## ◆ setRenderQueueGroupAndPriority()

virtual void Ogre::ParticleSystemRenderer::setRenderQueueGroupAndPriority | ( | uint8 | queueID,
|  | ushort | priority
| ) |  |
| pure virtual

Sets which render queue group and priority this renderer should target with it's output.

Implemented in Ogre::BillboardParticleRenderer.

## ◆ setKeepParticlesInLocalSpace()

virtual void Ogre::ParticleSystemRenderer::setKeepParticlesInLocalSpace | ( | bool | keepLocal | ) |
| pure virtual

Setting carried over from ParticleSystem.

Implemented in Ogre::BillboardParticleRenderer.

## ◆ _getSortMode()

virtual SortMode Ogre::ParticleSystemRenderer::_getSortMode | ( | void |  | ) | const
| pure virtual

Gets the desired particles sort mode of this renderer.

Implemented in Ogre::BillboardParticleRenderer.

## ◆ visitRenderables()

virtual void Ogre::ParticleSystemRenderer::visitRenderables | ( | Renderable::Visitor * | visitor,
|  | bool | debugRenderables = `false`
| ) |  |
| pure virtual

Required method to allow the renderer to communicate the Renderables it will be using to render the system to a visitor.

See also
  MovableObject::visitRenderables

Implemented in Ogre::BillboardParticleRenderer.

## ◆ getParamDictionary() [1/2]

ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) |
| inline inherited

Retrieves the parameter dictionary for this class.

Remarks
  Only valid to call this after createParamDictionary.

Returns
  Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc.

## ◆ getParamDictionary() [2/2]

const ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | const
| inline inherited

## ◆ getParameters()

const ParameterList& Ogre::StringInterface::getParameters | ( | void |  | ) | const
| inherited

Retrieves a list of parameters valid for this object.

Returns
  A reference to a static list of ParameterDef objects.

## ◆ setParameter()

bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value
| ) |  |
| inherited

Generic parameter setting method.

Remarks
  Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters

  name | The name of the parameter to set
  value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.

Returns
  true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

Referenced by Ogre::StringInterface::copyParametersTo().

## ◆ setParameterList()

void Ogre::StringInterface::setParameterList | ( | const NameValuePairList & | paramList | ) |
| inherited

Generic multiple parameter setting method.

Remarks
  Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters

  paramList | Name/value pair list

## ◆ getParameter()

String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const
| inline inherited

Generic parameter retrieval method.

Remarks
  Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type.

Parameters

  name | The name of the parameter to get

Returns
  String value of parameter, blank if not found

References Ogre::ParamCommand::doGet().

## ◆ copyParametersTo()

void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const
| inline inherited

Method for copying this object's parameters to another object.

Remarks
  This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop.

  Any unrecognised parameters will be ignored as with setParameter method.

Parameters

  dest | Pointer to object to have it's parameters set the same as this object.

References Ogre::StringInterface::setParameter().

## ◆ cleanupDictionary()

static void Ogre::StringInterface::cleanupDictionary | ( |  | ) |
| static inherited

Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

MaterialManager) initializes.

The documentation for this class was generated from the following file:

- OgreParticleSystemRenderer.h